/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Verify.xs. Do not edit this file, edit Verify.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Verify.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_mg_findext
#define NEED_newRV_noinc
#define NEED_sv_2pv_flags
#include "ppport.h"

#include <openssl/asn1.h>
#include <openssl/objects.h>
#include <openssl/bio.h>
#include <openssl/crypto.h>
#include <openssl/err.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/x509_vfy.h>

typedef X509 *Crypt__OpenSSL__X509;

struct OPTIONS {
   bool  trust_expired;
   bool  trust_no_local;
   bool  trust_onelogin;
};

#if 0
  "Skipped embedded POD."
#endif
#line 42 "Verify.xs"

#if DISABLED
int verify_cb(struct OPTIONS * options, int ok, X509_STORE_CTX * ctx)
{

    int cert_error = X509_STORE_CTX_get_error(ctx);

    if (!ok) {
        /*
         * Pretend that some errors are ok, so they don't stop further
         * processing of the certificate chain.  Setting ok = 1 does this.
         * After X509_verify_cert() is done, we verify that there were
         * no actual errors, even if the returned value was positive.
         */
        switch (cert_error) {
            case X509_V_ERR_NO_EXPLICIT_POLICY:
                /* fall thru */
            case X509_V_ERR_CERT_HAS_EXPIRED:
                if ( ! options->trust_expired ) {
                    break;
                }
                ok = 1;
                break;
                /* Continue even if the leaf is a self signed cert */
            case X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT:
                /* Continue after extension errors too */
            case X509_V_ERR_INVALID_CA:
            case X509_V_ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE:
                if ( !options->trust_onelogin )
                    break;
                ok = 1;
                break;
            case X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY:
                if ( !options->trust_no_local )
                    break;
                ok = 1;
                break;
            case X509_V_ERR_INVALID_NON_CA:
            case X509_V_ERR_PATH_LENGTH_EXCEEDED:
            case X509_V_ERR_INVALID_PURPOSE:
            case X509_V_ERR_CRL_HAS_EXPIRED:
            case X509_V_ERR_CRL_NOT_YET_VALID:
            case X509_V_ERR_UNHANDLED_CRITICAL_EXTENSION:
                ok = 1;
        }
        return ok;
    }
    return ok;
}
#endif

#if 0
  "Skipped embedded POD."
#endif
#line 117 "Verify.xs"

static SV *callback = (SV *) NULL;

static int cb1(ok, ctx)
    int ok;
    IV *ctx;
{
    dSP;
    int count;
    int i;

    //printf("Callback pointer: %p\n", ctx);
    //printf("Callback INT of pointer %lu\n", (unsigned long) PTR2IV(ctx));
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    EXTEND(SP, 2);

    PUSHs(newSViv(ok));                 // Pass ok as integer on the stack
    PUSHs(newSViv(PTR2IV(ctx)));        // Pass pointer address as integer
    PUTBACK;

    count = call_sv(callback, G_SCALAR);  // Call the verify_callback()

    SPAGAIN;
    if (count != 1)
        croak("ERROR - Perl callback returned more than one value\n");

    i = POPi;   // Get the return code from Perl verify_callback()
    PUTBACK;
    FREETMPS;
    LEAVE;

    return i;
}

#if 0
  "Skipped embedded POD."
#endif
#line 159 "Verify.xs"

static const char *ssl_error(void)
{
    return ERR_error_string(ERR_get_error(), NULL);
}

#if 0
  "Skipped embedded POD."
#endif
#line 170 "Verify.xs"

static const char *ctx_error(X509_STORE_CTX * ctx)
{
    return X509_verify_cert_error_string(X509_STORE_CTX_get_error(ctx));
}

// Taken from p5-Git-Raw
STATIC HV *ensure_hv(SV *sv, const char *identifier) {
    if (!SvROK(sv) || SvTYPE(SvRV(sv)) != SVt_PVHV)
    croak("Invalid type for '%s', expected a hash", identifier);

    return (HV *) SvRV(sv);
}

static int ssl_store_destroy(pTHX_ SV* var, MAGIC* magic) {
    X509_STORE * store;

    store = (X509_STORE *) magic->mg_ptr;
    if (!store)
        return 0;

    X509_STORE_free(store);
    return 1;
}

static const MGVTBL store_magic = { NULL, NULL, NULL, NULL, ssl_store_destroy };

#line 175 "Verify.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 319 "Verify.c"
#if OPENSSL_API_COMPAT >= 10100
#undef ERR_load_crypto_strings
#define ERR_load_crypto_strings()    /* nothing */
#undef OpenSSL_add_all_algorithms
#define OpenSSL_add_all_algorithms()    /* nothing */
#endif

XS_EUPXS(XS_Crypt__OpenSSL__Verify_register_verify_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify_register_verify_cb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fn");
    {
	SV *	fn = ST(0)
;
#line 225 "Verify.xs"
        /* this code seems to work fine as the perl function is called */
        /* Remember the Perl sub */
        if (callback == (SV *) NULL)
            callback = newSVsv(fn);
        else
            SvSetSV(callback, fn);
#line 343 "Verify.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__OpenSSL__Verify_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    {
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
#line 260 "Verify.xs"
        SV * CAfile = NULL;

        HV * options = newHV();

        X509_LOOKUP * cafile_lookup = NULL;
        X509_LOOKUP * cadir_lookup = NULL;
        X509_STORE * x509_store = NULL;
        SV **svp;
        SV *CApath = NULL;
        int noCApath = 0;
        int noCAfile = 0;
        int strict_certs = 1; // Default is strict openSSL verify
        SV * store = newSV(0);

#line 373 "Verify.c"
	SV *	RETVAL;
#line 277 "Verify.xs"
        if (items > 1) {
            if (ST(1) != NULL) {
                // TODO: ensure_string_sv
                CAfile = ST(1);
                if (strlen(SvPV_nolen(CAfile)) == 0) {
                    CAfile = NULL;
                }
            }

            if (items > 2)
                options = ensure_hv(ST(2), "options");

        }

        if (hv_exists(options, "noCAfile", strlen("noCAfile"))) {
            svp = hv_fetch(options, "noCAfile", strlen("noCAfile"), 0);
            if (SvIOKp(*svp)) {
                noCAfile = SvIV(*svp);
            }
        }

        if (hv_exists(options, "CApath", strlen("CApath"))) {
            svp = hv_fetch(options, "CApath", strlen("CApath"), 0);
            CApath = *svp;
        }

        if (hv_exists(options, "noCApath", strlen("noCApath"))) {
            svp = hv_fetch(options, "noCApath", strlen("noCApath"), 0);
            if (SvIOKp(*svp)) {
                noCApath = SvIV(*svp);
            }
        }

        if (hv_exists(options, "strict_certs", strlen("strict_certs"))) {
            svp = hv_fetch(options, "strict_certs", strlen("strict_certs"), 0);
            if (SvIOKp(*svp)) {
                strict_certs = SvIV(*svp);
            }
        }

        x509_store = X509_STORE_new();

        if (x509_store == NULL) {
            X509_STORE_free(x509_store);
            croak("failure to allocate x509 store: %s", ssl_error());
        }

        if (!strict_certs)
            X509_STORE_set_verify_cb_func(x509_store, cb1);

        if (CAfile != NULL || !noCAfile) {
            cafile_lookup = X509_STORE_add_lookup(x509_store, X509_LOOKUP_file());
            if (cafile_lookup == NULL) {
                X509_STORE_free(x509_store);
                croak("failure to add lookup to store: %s", ssl_error());
            }
            if (CAfile != NULL) {
                if (!X509_LOOKUP_load_file(cafile_lookup, SvPV_nolen(CAfile), X509_FILETYPE_PEM)) {
                    X509_STORE_free(x509_store);
                    croak("Error loading file %s: %s\n", SvPV_nolen(CAfile),
                        ssl_error());
                }
            } else {
                X509_LOOKUP_load_file(cafile_lookup, NULL, X509_FILETYPE_DEFAULT);
            }
        }

        if (CApath != NULL || !noCApath) {
            cadir_lookup = X509_STORE_add_lookup(x509_store, X509_LOOKUP_hash_dir());
            if (cadir_lookup == NULL) {
                X509_STORE_free(x509_store);
                croak("failure to add lookup to store: %s", ssl_error());
            }
            if (CApath != NULL) {
                if (!X509_LOOKUP_add_dir(cadir_lookup, SvPV_nolen(CApath), X509_FILETYPE_PEM)) {
                    X509_STORE_free(x509_store);
                    croak("Error loading directory %s\n", SvPV_nolen(CApath));
                }
            } else {
                X509_LOOKUP_add_dir(cadir_lookup, NULL, X509_FILETYPE_DEFAULT);
            }
        }

        HV * attributes = newHV();

        SV *const self = newRV_noinc( (SV *)attributes );

        sv_magicext(store, NULL, PERL_MAGIC_ext,
            &store_magic, (const char *)x509_store, 0);

        if((hv_store(attributes, "STORE", 5, store, 0)) == NULL)
            croak("unable to init store");

        RETVAL = sv_bless( self, gv_stashpv( class, 0 ) );

        // Empty the currect thread error queue
        // https://www.openssl.org/docs/man1.1.1/man3/ERR_clear_error.html
        ERR_clear_error();

#line 475 "Verify.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Verify_ctx_error_code); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify_ctx_error_code)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctx");
    {
	IV	ctx = (IV)SvIV(ST(0))
;
#line 395 "Verify.xs"
#line 493 "Verify.c"
	int	RETVAL;
	dXSTARG;
#line 396 "Verify.xs"
        /* printf("ctx_error_code - int holding pointer: %lu\n", (unsigned long) ctx); */
        /* printf("ctx_error_code - Pointer to ctx: %p\n", (void *) INT2PTR(SV * , ctx)); */

        RETVAL = X509_STORE_CTX_get_error((X509_STORE_CTX *) INT2PTR(SV *, ctx));

#line 502 "Verify.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__OpenSSL__Verify_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify_verify)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, x509");
    {
	HV *	self;
	Crypt__OpenSSL__X509	x509;
#line 432 "Verify.xs"
        X509_STORE_CTX * csc;

#line 522 "Verify.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Crypt::OpenSSL::Verify::verify",
				"self");
		}
	} STMT_END
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Crypt::OpenSSL::X509")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    x509 = INT2PTR(Crypt__OpenSSL__X509,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"Crypt::OpenSSL::Verify::verify",
			"x509", "Crypt::OpenSSL::X509",
			refstr, ST(1)
		);
	}
;
#line 435 "Verify.xs"
        SV **svp;
        MAGIC* mg;
        X509_STORE * store = NULL;
        //bool strict_certs = 1;
        //struct OPTIONS trust_options;
        //trust_options.trust_expired = 0;
        //trust_options.trust_no_local = 0;
        //trust_options.trust_onelogin = 0r
        //

        if (x509 == NULL)
            croak("no cert to verify");

        csc = X509_STORE_CTX_new();
        if (csc == NULL)
            croak("X.509 store context allocation failed: %s", ssl_error());

        if (!hv_exists(self, "STORE", strlen("STORE")))
            croak("STORE not found in self!\n");

        svp = hv_fetch(self, "STORE", strlen("STORE"), 0);

        if (!SvMAGICAL(*svp) || (mg = mg_findext(*svp, PERL_MAGIC_ext, &store_magic)) == NULL)
            croak("STORE is invalid");

        store = (X509_STORE *) mg->mg_ptr;

        X509_STORE_set_flags(store, 0);

        if (!X509_STORE_CTX_init(csc, store, x509, NULL)) {
            X509_STORE_CTX_free(csc);
            croak("store ctx init: %s", ssl_error());
        }

        RETVAL = X509_verify_cert(csc);

        //if (hv_exists(self, "strict_certs", strlen("strict_certs"))) {
        //    svp = hv_fetch(self, "strict_certs", strlen("strict_certs"), 0);
        //    if (SvIOKp(*svp)) {
        //        strict_certs = SvIV(*svp);
        //    }
        //}
        //if (hv_exists(self, "trust_expired", strlen("trust_expired"))) {
        //    svp = hv_fetch(self, "trust_expired", strlen("trust_expired"), 0);
        //    if (SvIOKp(*svp)) {
        //        trust_options.trust_expired = SvIV(*svp);
        //    }
        //}
        //if (hv_exists(self, "trust_onelogin", strlen("trust_onelogin"))) {
        //    svp = hv_fetch(self, "trust_onelogin", strlen("trust_onelogin"), 0);
        //    if (SvIOKp(*svp)) {
        //        trust_options.trust_onelogin = SvIV(*svp);
        //    }
        //}
        //if (hv_exists(self, "trust_no_local", strlen("trust_no_local"))) {
        //    svp = hv_fetch(self, "trust_no_local", strlen("trust_no_local"), 0);
        //    if (SvIOKp(*svp)) {
        //        trust_options.trust_no_local = SvIV(*svp);
        //    }
        //}
        //
        //This actually does not accomplish what we want as it essentially
        //checks only the last certificate not the chain that might have
        //acceptable errors.  Original code considered errors on this last
        //certificate as real errors.
        //if ( !RETVAL && !strict_certs ) {
        //    int cb = verify_cb(&trust_options, RETVAL, csc);
        //    RETVAL = cb;
        //}

        if (!RETVAL)
            croak("verify: %s", ctx_error(csc));

        X509_STORE_CTX_free(csc);

#line 629 "Verify.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if OPENSSL_API_COMPAT >= 10100
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Crypt__OpenSSL__Verify___X509_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify___X509_cleanup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 518 "Verify.xs"
        /* deinitialisation is done automatically */
#line 651 "Verify.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Crypt__OpenSSL__Verify___X509_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__OpenSSL__Verify___X509_cleanup)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 525 "Verify.xs"
    CRYPTO_cleanup_all_ex_data();
    ERR_free_strings();
    ERR_remove_state(0);
    EVP_cleanup();
#line 675 "Verify.c"
	PUTBACK;
	return;
    }
}

#endif
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__OpenSSL__Verify); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__OpenSSL__Verify)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Crypt::OpenSSL::Verify::register_verify_cb", XS_Crypt__OpenSSL__Verify_register_verify_cb);
        newXS_deffile("Crypt::OpenSSL::Verify::new", XS_Crypt__OpenSSL__Verify_new);
        newXS_deffile("Crypt::OpenSSL::Verify::ctx_error_code", XS_Crypt__OpenSSL__Verify_ctx_error_code);
        newXS_deffile("Crypt::OpenSSL::Verify::verify", XS_Crypt__OpenSSL__Verify_verify);
#if XSubPPtmpAAAA
        newXS_deffile("Crypt::OpenSSL::Verify::__X509_cleanup", XS_Crypt__OpenSSL__Verify___X509_cleanup);
#endif
#if XSubPPtmpAAAB
        newXS_deffile("Crypt::OpenSSL::Verify::__X509_cleanup", XS_Crypt__OpenSSL__Verify___X509_cleanup);
#endif

    /* Initialisation Section */

#line 208 "Verify.xs"
    ERR_load_crypto_strings();
#if OPENSSL_API_COMPAT < 10100
    ERR_load_ERR_strings();
#endif
    OpenSSL_add_all_algorithms();

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#line 734 "Verify.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
